package com.njzscloud.dispose.finance.service;

import cn.hutool.core.bean.BeanUtil;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.njzscloud.common.mp.support.PageParam;
import com.njzscloud.common.mp.support.PageResult;
import com.njzscloud.common.security.util.SecurityUtil;
import com.njzscloud.dispose.finance.mapper.ExpenseItemMapper;
import com.njzscloud.dispose.finance.pojo.entity.ExpenseItemEntity;
import com.njzscloud.dispose.finance.pojo.param.AddExpenseItemParam;
import com.njzscloud.dispose.finance.pojo.param.ModifyExpenseItemParam;
import com.njzscloud.dispose.sys.auth.pojo.result.MyResult;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * 收费项目
 *
 * @author ljw
 */
@Slf4j
@Service
@RequiredArgsConstructor
public class ExpenseItemService extends ServiceImpl<ExpenseItemMapper, ExpenseItemEntity> {

    /**
     * 新增
     */
    public void add(AddExpenseItemParam addExpenseItemParam) {
        MyResult userDetail = SecurityUtil.loginUser();
        this.save(BeanUtil.copyProperties(addExpenseItemParam, ExpenseItemEntity.class)
            .setUserId(userDetail.getUserId())
            .setCustomerId(userDetail.getCurrentCustomerId())
            .setOrgId(userDetail.getCurrentOrgId()));
    }

    /**
     * 修改
     */
    public void modify(ModifyExpenseItemParam modifyExpenseItemParam) {
        this.updateById(BeanUtil.copyProperties(modifyExpenseItemParam, ExpenseItemEntity.class));
    }

    /**
     * 删除
     */
    @Transactional(rollbackFor = Exception.class)
    public void del(List<Long> ids) {
        this.removeBatchByIds(ids);
    }

    /**
     * 详情
     */
    public ExpenseItemEntity detail(Long id) {
        return this.getById(id);
    }

    /**
     * 分页查询
     */
    public PageResult<ExpenseItemEntity> paging(PageParam pageParam, ExpenseItemEntity expenseItemEntity) {
        return PageResult.of(this.page(pageParam.toPage(), Wrappers.query(expenseItemEntity)));
    }
}
